org.apache.lucene.search.join

## Class ToParentBlockJoinCollector

- java.lang.Object
- - org.apache.lucene.search.Collector
  - - org.apache.lucene.search.join.ToParentBlockJoinCollector

-     public class ToParentBlockJoinCollector
      extends Collector

  Collects parent document hits for a Query containing one more more BlockJoinQuery clauses, sorted by the specified parent Sort. Note that this cannot perform arbitrary joins; rather, it requires that all joined documents are indexed as a doc block (using `IndexWriter.addDocuments(java.lang.Iterable<? extends java.lang.Iterable<? extends org.apache.lucene.index.IndexableField>>)` or `IndexWriter.updateDocuments(org.apache.lucene.index.Term, java.lang.Iterable<? extends java.lang.Iterable<? extends org.apache.lucene.index.IndexableField>>)`). Ie, the join is computed at index time.

  The parent Sort must only use fields from the parent documents; sorting by field in the child documents is not supported.

  You should only use this collector if one or more of the clauses in the query is a `ToParentBlockJoinQuery`. This collector will find those query clauses and record the matching child documents for the top scoring parent documents.

  Multiple joins (star join) and nested joins and a mix of the two are allowed, as long as in all cases the documents corresponding to a single row of each joined parent table were indexed as a doc block.

  For the simple star join you can retrieve the `TopGroups` instance containing each `ToParentBlockJoinQuery`'s matching child documents for the top parent groups, using `getTopGroups(org.apache.lucene.search.join.ToParentBlockJoinQuery, org.apache.lucene.search.Sort, int, int, int, boolean)`. Ie, a single query, which will contain two or more `ToParentBlockJoinQuery`'s as clauses representing the star join, can then retrieve two or more `TopGroups` instances.

  For nested joins, the query will run correctly (ie, match the right parent and child documents), however, because TopGroups is currently unable to support nesting (each group is not able to hold another TopGroups), you are only able to retrieve the TopGroups of the first join. The TopGroups of the nested joins will not be correct. See `org.apache.lucene.search.join` for a code sample.

  WARNING: This API is experimental and might change in incompatible ways in the next release.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ToParentBlockJoinCollector(Sort sort, int numParentHits, boolean trackScores, boolean trackMaxScore)` Creates a ToParentBlockJoinCollector.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `acceptsDocsOutOfOrder()`
    `void` | `collect(int parentDoc)`
    `float` | `getMaxScore()` Returns the highest score across all collected parent hits, as long as `trackMaxScores=true` was passed `on construction`.
    `TopGroups<Integer>` | `getTopGroups(ToParentBlockJoinQuery query, Sort withinGroupSort, int offset, int maxDocsPerGroup, int withinGroupOffset, boolean fillSortFields)` Return the TopGroups for the specified BlockJoinQuery.
    `void` | `setNextReader(AtomicReaderContext context)`
    `void` | `setScorer(Scorer scorer)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ToParentBlockJoinCollector

          public ToParentBlockJoinCollector(Sort sort,
                                    int numParentHits,
                                    boolean trackScores,
                                    boolean trackMaxScore)
                                     throws IOException

      Creates a ToParentBlockJoinCollector. The provided sort must not be null. If you pass true trackScores, all ToParentBlockQuery instances must not use ScoreMode.None.
      Throws:
        `IOException`

  - ### Method Detail

    - #### collect

          public void collect(int parentDoc)
                       throws IOException

      Specified by:
        `collect` in class `Collector`
      Throws:
        `IOException`

    - #### setNextReader

          public void setNextReader(AtomicReaderContext context)
                             throws IOException

      Specified by:
        `setNextReader` in class `Collector`
      Throws:
        `IOException`

    - #### acceptsDocsOutOfOrder

          public boolean acceptsDocsOutOfOrder()

      Specified by:
        `acceptsDocsOutOfOrder` in class `Collector`

    - #### setScorer

          public void setScorer(Scorer scorer)

      Specified by:
        `setScorer` in class `Collector`

    - #### getTopGroups

          public TopGroups<Integer> getTopGroups(ToParentBlockJoinQuery query,
                                        Sort withinGroupSort,
                                        int offset,
                                        int maxDocsPerGroup,
                                        int withinGroupOffset,
                                        boolean fillSortFields)
                                          throws IOException

      Return the TopGroups for the specified BlockJoinQuery. The groupValue of each GroupDocs will be the parent docID for that group. Note that the `GroupDocs.totalHits`, which would be the total number of child documents matching that parent, is not computed (will always be 0). Returns null if no groups matched.
      Throws:
        `IOException`

    - #### getMaxScore

          public float getMaxScore()

      Returns the highest score across all collected parent hits, as long as `trackMaxScores=true` was passed `on construction`. Else, this returns `Float.NaN`

Copyright © 2000-2013 Apache Software Foundation. All Rights Reserved.